Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Vol As Double
        Dim Trans As Double
        Dim Speich As Double
        Dim Entf As Double
        Dim Zeit As Double
        Dim Abs As Double
        Dim Sigma As Double
        Dim WvS As Double
        Dim Gl_n1, sn As Double

        Dim Num As Integer

        Dim sVol, sTrans, sSpeich, sEntf, sZeit As String

        ' Eingabe des Volumenstroms
        Vol = -1
        Do
            sVol = InputBox("Bitte Volumenstrom eingeben [m/s]", "Absenkung nach Theis", "0,005")
            If Me.Ist_Zahl(sVol) Then
                Vol = CDbl(sVol)
            End If
        Loop Until (Vol <> -1)

        ' Eingabe der Transmissivitt
        Trans = -1
        Do
            sTrans = InputBox("Bitte Transmissivitt eingeben [m/s]", "Absenkung nach Theis", "1e-3")
            If Me.Ist_Zahl(sTrans) Then
                Trans = CDbl(sTrans)
            End If
        Loop Until Trans <> -1

        ' Eingabe des Speicherkoeffizienten
        Speich = -1
        Do
            sSpeich = InputBox("Bitte Speicherkoeffizienten eingeben", "Absenkung nach Theis", "1e-4")
            If Me.Ist_Zahl(sSpeich) Then
                Speich = CDbl(sSpeich)
            End If
        Loop Until Speich <> -1

        ' Eingabe der Entfernung
        Entf = -1
        Do
            sEntf = InputBox("Bitte Entfernung eingeben [m]", "Absenkung nach Theis", "10")
            If Me.Ist_Zahl(sEntf) Then
                Entf = CDbl(sEntf)
            End If
        Loop Until Entf <> -1

        ' Eingabe der Pumpzeit
        Zeit = -1
        Do
            sZeit = InputBox("Bitte Pumpzeit eingeben [s]", "Absenkung nach Theis", "10")
            If Me.Ist_Zahl(sZeit) Then
                Zeit = CDbl(sZeit)
            End If
        Loop Until Zeit <> -1


        Me.Label8.Text = Vol.ToString
        Me.Label10.Text = Trans.ToString
        Me.Label11.Text = Speich.ToString
        Me.Label12.Text = Entf.ToString
        Me.Label13.Text = Zeit.ToString

        ' Berechnung von Sigma
        Sigma = (Entf * Entf * Speich) / (4 * Trans * Zeit)
        Me.Label3.Text = Sigma.ToString

        ' Berechnung der Absenkung nach Jacob und Cooper
        Abs = (Vol / (4 * Math.PI * Trans)) * (-Math.Log(1.781 * Sigma))
        Me.Label20.Text = "Absenkung = " & Abs.ToString("#0.0000") & " m"

        ' Berechnung der Absenkung nach Theis
        Num = 2
        Gl_n1 = Sigma
        WvS = -Math.Log(1.781 * Sigma) + Sigma

        Do
            Gl_n1 = (-1) * (Num - 1) * Sigma / (Num * Num) * Gl_n1
            sn = WvS
            WvS = WvS + Gl_n1
            Num = Num + 1
        Loop Until (Math.Abs((sn - WvS) / WvS) < 0.000001#)

        Abs = Vol / (4 * Math.PI * Trans) * WvS
        Me.Label21.Text = "Absenkung = " & Abs.ToString("#0.0000") & " m"
    End Sub

    ' Prft, ob die bergebene Zeichenfolge Zeichen enthlt und eine Zahl darstellen
    ' Gibt entsprechend der Prfung True oder False zurck
    Private Function Ist_Zahl(ByVal Wert As String) As Boolean
        If (Wert IsNot Nothing) AndAlso IsNumeric(Wert) Then
            Return True
        Else
            Return False
        End If
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()
    End Sub
End Class
