Public Class Form1

    ' Behandelt das Ereignis, wenn der Nutzer auf die Schaltflche geklickt hat
    ' Die bergebenen Variablen sind Standardargumente, welche auch abgefragt werden knnen
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim Messwerte(6) As Double  ' Array der Messwerte
        Dim i As Integer            ' Laufvariable
        Dim Fl As Double            ' Flche
        Dim SW As Double            ' Schrittweite

        ' Zuweisen der Eingabewerte
        Messwerte(0) = CType(Me.TextBox1.Text, Double)
        Messwerte(1) = CType(Me.TextBox3.Text, Double)
        Messwerte(2) = CType(Me.TextBox4.Text, Double)
        Messwerte(3) = CType(Me.TextBox5.Text, Double)
        Messwerte(4) = CType(Me.TextBox6.Text, Double)
        Messwerte(5) = CType(Me.TextBox7.Text, Double)
        Messwerte(6) = CType(Me.TextBox8.Text, Double)

        SW = 200
        Fl = 0.0#

        ' Berechnung nach der Trapezregel
        For i = 0 To Messwerte.Length - 2
            Fl = Fl + SW * (Math.Abs(Messwerte(i) + Messwerte(i + 1))) / 2
        Next i

        ' Ergebnisausgabe
        Me.ListBox1.Items.Clear()
        Me.ListBox1.Items.Add("Ergebnis nach Trapezregel")
        Me.ListBox1.Items.Add("F = " & Math.Round(Fl, 4).ToString)


        ' Berechnung nach Simpsonregel
        Fl = 0.0#
        For i = 0 To Messwerte.Length - 1
            Select Case i
                Case 0, Messwerte.Length - 1
                    Fl = Fl + Messwerte(i)

                Case Else
                    ' ist i eine gerade Zahl?
                    If (i Mod 2) = 0 Then
                        Fl = Fl + 2 * Messwerte(i)

                    Else
                        Fl = Fl + 4 * Messwerte(i)
                    End If
            End Select
        Next i

        Fl = Fl * SW / 3.0#

        ' Ergebnisausgabe
        Me.ListBox1.Items.Add("")
        Me.ListBox1.Items.Add("Ergebnis nach Simpsonregel")
        Me.ListBox1.Items.Add("F = " & Math.Round(Fl, 4).ToString)
    End Sub

    Private Sub TextBox1_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox1.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox3_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox3.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox4_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox4.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox5_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox5.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox6_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox6.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox7_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox7.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub

    Private Sub TextBox8_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox8.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte gltige Zahl eingeben!", MsgBoxStyle.Information, "Numerische Integration")
        End If
    End Sub
End Class
