Public Class Form1

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim kf_Wert As Double
        Dim Speich As Double
        Dim Vol As Double
        Dim Entf As Double
        Dim Zeit As Double
        Dim num As Integer
        Dim Abs As Double
        Dim Sigma As Double
        Dim WvS, WvS_alt As Double
        Dim dif As Double
        Dim zRn As Double

        ' Zuweisen der eingegebenen Werte
        kf_Wert = CDbl(Me.TextBox1.Text)
        Speich = CDbl(Me.TextBox2.Text)
        Vol = CDbl(Me.TextBox3.Text)
        Entf = CDbl(Me.TextBox4.Text)
        Zeit = CDbl(Me.TextBox5.Text)
        zRn = CDbl(Me.TextBox6.Text)

        If (Me.ListBox1.Items IsNot Nothing) AndAlso (ListBox1.Items.Count > 0) Then
            Me.ListBox1.Items.Add("")
        End If
        Me.ListBox1.Items.Add("Eingabeparameter")
        Me.ListBox1.Items.Add(vbTab & "kf-Wert = " & kf_Wert & " m/s")
        Me.ListBox1.Items.Add(vbTab & "S-Wert = " & Speich)
        Me.ListBox1.Items.Add(vbTab & "Volumenstrom = " & Vol & " m/s")
        If Me.CheckBox1.Checked Then
            Me.ListBox1.Items.Add(vbTab & "ungespannter Grundwasserleiter")
        Else
            Me.ListBox1.Items.Add(vbTab & "gespannter Grundwasserleiter")
        End If

        ' Berechnung der Absenkung
        Sigma = Speich * Entf * Entf / (4 * Zeit * kf_Wert * zRn)

        WvS = -Math.Log(1.78102# * Sigma) + Sigma
        dif = Sigma
        num = 2

        Do
            dif = (-1) * Sigma * (num - 1) / (num * num) * dif
            WvS_alt = WvS
            WvS = WvS + dif
            num = num + 1
        Loop Until (Math.Abs((WvS - WvS_alt) / WvS) < 0.00001)

        ' soll ein ungespannter GWL betrachetet werden?
        If Me.CheckBox1.Checked Then
            Abs = zRn - Math.Sqrt((zRn * zRn) - (Vol / (2 * Math.PI * kf_Wert) * WvS))
        Else
            Abs = Vol / (4 * Math.PI * kf_Wert * zRn) * WvS
        End If
        Me.ListBox1.Items.Add("")
        Me.ListBox1.Items.Add("Absenkung = " & Abs.ToString("#0.000") & " m")
        Dim Zeichen(CInt(Me.ListBox1.Width / Len("-"))) As String
        Me.ListBox1.Items.Add(String.Join("-", Zeichen))

    End Sub

    ' berprfen der Eingaben
    Private Sub TextBox1_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox1.Validating
        If Not IsNumeric(Me.TextBox1.Text) Then
            e.Cancel = True
            MsgBox("Bitte eine gltige Zahl eingeben!", MsgBoxStyle.Exclamation)
        End If
    End Sub

    Private Sub TextBox2_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox2.Validating
        If Not IsNumeric(Me.TextBox2.Text) Then
            e.Cancel = True
            MsgBox("Bitte eine gltige Zahl eingeben!", MsgBoxStyle.Exclamation)
        End If
    End Sub

    Private Sub TextBox3_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox3.Validating
        If Not IsNumeric(Me.TextBox3.Text) Then
            e.Cancel = True
            MsgBox("Bitte eine gltige Zahl eingeben!", MsgBoxStyle.Exclamation)
        End If
    End Sub

    Private Sub TextBox4_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox4.Validating
        If Not IsNumeric(Me.TextBox4.Text) Then
            e.Cancel = True
            MsgBox("Bitte eine gltige Zahl eingeben!", MsgBoxStyle.Exclamation)
        End If
    End Sub

    Private Sub TextBox5_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox5.Validating
        If Not IsNumeric(Me.TextBox5.Text) Then
            e.Cancel = True
            MsgBox("Bitte eine gltige Zahl eingeben!", MsgBoxStyle.Exclamation)
        End If
    End Sub

    Private Sub TextBox6_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBox6.Validating
        If Not IsNumeric(Me.TextBox6.Text) Then
            e.Cancel = True
            MsgBox("Bitte eine gltige Zahl eingeben!", MsgBoxStyle.Exclamation)
        End If
    End Sub
End Class
